Imports System
Imports System.IO
' File transfer form & module... anything to do with file transfer is in this form..
' Also attached to this form is the TCP socket class

Public Class Files
    Enum Trans_State
        Send ' Run as host
        Recv ' Run as client 
    End Enum
    Private Loc_User As MainF.User_Type
    Private WithEvents C_Timer As System.Windows.Forms.Timer
    Private WithEvents O_Timer As System.Windows.Forms.Timer
    Private Loc_Remote As Net.IPEndPoint
    Private WithEvents Socket As TCPSocket
    Private Int_State As Trans_State
    Private Time_Out As Integer
    Private Time_Retry As Integer
    Private Time_Close As Integer
    Private Loc_Port As Integer
    Private Loc_Index As Integer
    Private Loc_File As String
    Private Save_File As String
    Private File_Size As Long
    Private File_Pos As Long
    Private File_data() As Byte
    Private File_Block As Integer
    Private File_IO As FileStream

    Friend Property Port() As Integer
        Get
            Return Loc_Port
        End Get
        Set(ByVal Value As Integer)
            Loc_Port = Value
        End Set
    End Property

    Friend Property Index() As Integer
        Get
            Return Loc_Index
        End Get
        Set(ByVal Value As Integer)
            Loc_Index = Value
        End Set
    End Property

    Friend Property File_User() As MainF.User_Type
        Get
            Return Loc_User
        End Get
        Set(ByVal Value As MainF.User_Type)
            Loc_User = Value
        End Set
    End Property

    Friend Property FileName() As String
        Get
            Return Loc_File
        End Get
        Set(ByVal Value As String)
            Save_File = Value
        End Set
    End Property

    Public Function Init() As String
        Dim Dest_IP As New Net.IPEndPoint(Net.IPAddress.Parse("0.0.0.0"), 0)
        Loc_Remote = Dest_IP
        Int_State = Trans_State.Send
        Return Sec_Init()
    End Function

    Public Function Init(ByVal Method As Trans_State, ByVal Remote As Net.IPEndPoint) As String
        Loc_Remote = Remote
        Int_State = Method
        Return Sec_Init()
    End Function

    Public Function Init(ByVal Method As Trans_State, ByVal RemoteHost As String, ByVal RemotePort As Integer) As String
        Dim Dest_IP As New Net.IPEndPoint(Net.IPAddress.Parse(RemoteHost), RemotePort)
        Loc_Remote = Dest_IP
        Int_State = Method
        Return Sec_Init()
    End Function

    Private Function Sec_Init() As String
        Loc_File = ""
        Select Case Int_State
            Case Trans_State.Send
                OFD1.Multiselect = False
                OFD1.FileName = ""
                OFD1.Title = "IP-CHAT : Please select file to send "
                OFD1.ShowDialog()
                Return OFD1.FileName
            Case Trans_State.Recv
                SFD1.CheckPathExists = True
                SFD1.CreatePrompt = False
                SFD1.OverwritePrompt = True
                SFD1.FileName = Save_File
                SFD1.Title = "IP-CHAT : " & Loc_User.Name & " is sending you a File: Please select saving Location"
                SFD1.ShowDialog()
        End Select
        Return ""
    End Function

    Private Sub Socket_Connection_Complete(ByVal Remote_IP As System.Net.EndPoint) Handles Socket.Connection_Complete
        Label1.Text = "Connection Completed"
        C_Timer.Enabled = False 'Conection complete - do not close..
        O_Timer.Enabled = True
        Time_Out = 30
        Time_Retry = 4
        'Start data transfer according to Host / Client setup..
        Socket.Send("FDS1")
    End Sub

    Private Sub Socket_Connection_Error() Handles Socket.Connection_Error
        Label1.Text = "Connection Lost"
        Time_Close = 30
    End Sub

    Private Sub Socket_Connection_Request(ByVal Remote_IP As System.Net.EndPoint) Handles Socket.Connection_Request
        Label1.Text = "Connection request recieved"
        Time_Close = 60 ' 1 min to complete conection
    End Sub

    Private Sub Files_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Try
            Socket.Close()
            Socket = Nothing
        Catch ex As Exception
            'Ignore - socket never opened..
        End Try
        Try
            File_IO.Close()
            File_IO = Nothing
        Catch ex As Exception
            'Ignore - File was never opened..
        End Try
        C_Timer = Nothing
        O_Timer = Nothing
        Close_File(Loc_Index)
    End Sub

    Private Sub Socket_Data_Arrival(ByVal Data As String, ByVal Source As System.Net.IPAddress) Handles Socket.Data_Arrival
        Dim Net_Data() As String
        Dim Tmp_A_byte() As Byte
        Dim Tmp_Int As Integer
        Net_Data = Split(Data, ":", 4, CompareMethod.Text)
        Select Case Net_Data(0)
            Case "FDS1" ' "FDS1:[size]"
                If Int_State = Trans_State.Send Then
                    File_IO = New FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.Read, 512, FileOptions.SequentialScan)
                    'File_IP = New StreamReader(File_IO)
                    File_Size = File_IO.Length
                    Label1.Text = "Transfer in progress" & vbCrLf & FileName
                    Socket.Send("FDS1:" & CStr(File_Size))
                    PBar1.Maximum = CInt(File_Size / 512)
                    PBar1.Value = PBar1.Maximum
                    C_Timer.Enabled = False 'Conection complete - do not close..
                    O_Timer.Enabled = True
                    Time_Out = 30
                    Time_Retry = 4
                Else
                    File_IO = New FileStream(FileName, FileMode.Create, FileAccess.Write, FileShare.None, 512, FileOptions.SequentialScan)
                    'File_OP = New StreamWriter(File_IO)
                    File_Size = CLng(Net_Data(1))
                    PBar1.Maximum = CInt(File_Size / 512)
                    PBar1.Value = 0
                    Socket.Send("FDS2")
                    Label1.Text = "Transfer in progress" & vbCrLf & FileName
                    C_Timer.Enabled = False 'Conection complete - do not close..
                    O_Timer.Enabled = True
                    Time_Out = 30
                    Time_Retry = 4
                End If
            Case "FDS2" ' "FDS2"
                If Int_State = Trans_State.Send Then
                    File_Pos = 0
                    ReDim Tmp_A_byte(511)
                    File_Block = File_IO.Read(Tmp_A_byte, 0, 512)
                    File_data = System.Text.Encoding.ASCII.GetBytes("FDS3:" & CStr(File_Pos) & ":" & File_Block & ":")
                    Tmp_Int = File_data.GetUpperBound(0)
                    ReDim Preserve File_data(Tmp_Int + File_Block)
                    'File_IP.ReadBlock(File_data, 0, 512)
                    Tmp_A_byte.CopyTo(File_data, Tmp_Int + 1)
                    Socket.Send(File_data)
                    PBar1.Value = PBar1.Maximum - CInt(File_Pos / 512)
                    'Debug.Print(File_data)
                    Time_Out = 30
                    Time_Retry = 4
                End If
            Case "FDS3" ' "FDS3:[pos]:[size]:[data]"
                If Int_State = Trans_State.Recv Then
                    File_Pos = CInt(Net_Data(1))
                    File_Block = CInt(Net_Data(2))
                    ReDim Tmp_A_byte(0)
                    Socket.Get_Raw(Tmp_A_byte)
                    Tmp_Int = Tmp_A_byte.GetUpperBound(0) - File_Block
                    File_IO.Write(Tmp_A_byte, Tmp_Int + 1, File_Block)
                    Socket.Send("FDS4:" & CStr(File_Pos + File_Block))
                    PBar1.Value = CInt(File_Pos / 512)
                    'File_OP.Write(Net_Data(3))
                    'File_OP.Flush()
                    Time_Out = 30
                    Time_Retry = 4
                End If
            Case "FDS4" ' "FDS4:[pos]"
                If Int_State = Trans_State.Send Then
                    File_Pos = CInt(Net_Data(1))
                    'File_Block = File_IO.Read(File_data, 0, 512)
                    ReDim Tmp_A_byte(511)
                    File_Block = File_IO.Read(Tmp_A_byte, 0, 512)
                    If File_Block <> 512 Then
                        File_data = System.Text.Encoding.ASCII.GetBytes("FDS5:" & CStr(File_Pos) & ":" & File_Block & ":")
                        'Socket.Send("FDS5:" & CStr(File_Pos) & ":" & File_Block & ":" & System.Text.Encoding.ASCII.GetString(File_data))
                    Else
                        File_data = System.Text.Encoding.ASCII.GetBytes("FDS3:" & CStr(File_Pos) & ":" & File_Block & ":")
                        'Socket.Send("FDS3:" & CStr(File_Pos) & ":" & File_Block & ":" & System.Text.Encoding.ASCII.GetString(File_data))
                    End If
                    Tmp_Int = File_data.GetUpperBound(0)
                    ReDim Preserve Tmp_A_byte(File_Block - 1)
                    ReDim Preserve File_data(Tmp_Int + File_Block)
                    'File_IP.ReadBlock(File_data, 0, 512)
                    Tmp_A_byte.CopyTo(File_data, Tmp_Int + 1)
                    Socket.Send(File_data)
                    PBar1.Value = PBar1.Maximum - CInt(File_Pos / 512)
                    'Debug.Print(File_data)
                    Time_Out = 30
                    Time_Retry = 4
                End If
            Case "FDS5" ' "FDS5:[pos]:[size]:[data]"
                If Int_State = Trans_State.Recv Then
                    File_Pos = CInt(Net_Data(1))
                    File_Block = CInt(Net_Data(2))
                    File_IO.Write(System.Text.Encoding.ASCII.GetBytes(Net_Data(3)), 0, File_Block)
                    File_IO.Flush()
                    'File_OP.Write(Net_Data(3))
                    'File_OP.Close()
                    'File_OP = Nothing
                    File_IO.Close()
                    File_IO = Nothing
                    Socket.Send("FDS6")
                    Label1.Text = "Recieve Complete"
                    Socket.Close()
                    Socket = Nothing
                    C_Timer.Enabled = True
                    O_Timer.Enabled = False
                    Time_Close = 10
                End If
            Case "FDS6" ' "FDS6"
                'File_IP.Close()
                'File_IP = Nothing
                File_IO.Close()
                File_IO = Nothing
                Label1.Text = "Send Complete"
                Socket.Close()
                Socket = Nothing
                C_Timer.Enabled = True
                O_Timer.Enabled = False
                Time_Close = 10
        End Select

    End Sub

    Private Sub Socket_Socket_Error(ByVal Err As System.Exception) Handles Socket.Socket_Error
        Label1.Text = "Connection Error occured Please try again" & vbCrLf & "This window will close automaticaly." & vbCrLf & Err.Message
        Time_Close = 30
    End Sub

    Private Sub Files_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        C_Timer = New System.Windows.Forms.Timer
        O_Timer = New System.Windows.Forms.Timer
        C_Timer.Interval = 1000
        C_Timer.Enabled = True
        Time_Close = 300 ' Five min limit for file accept 
    End Sub

    Private Sub C_Timer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles C_Timer.Tick
        Time_Close = Time_Close - 1
        If Time_Close < 1 Then
            Me.Close()
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()
    End Sub

    Private Sub OFD1_FileOk(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OFD1.FileOk
        Socket = New TCPSocket
        If Not Socket.Init(TCPSocket.TCP_State.Listen, 0) Then
            MsgBox("Unable to Start TCP Host", MsgBoxStyle.Critical, "IP Chat")
            Time_Close = 30
            Exit Sub
        End If
        Loc_Port = Socket.Loc_Port
        Loc_File = OFD1.FileName
        Time_Close = 300
    End Sub

    Private Sub SFD1_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles SFD1.FileOk
        Socket = New TCPSocket
        If Not Socket.Init(TCPSocket.TCP_State.Client, 0) Then
            MsgBox("Unable to Start TCP Client", MsgBoxStyle.Critical, "IP Chat")
            Me.Dispose()
        End If
        Socket.Connect(Loc_Remote)
        Loc_Port = Socket.Loc_Port
        Loc_File = SFD1.FileName
        Time_Close = 300
    End Sub

End Class