' Any functions relating to network conectivity is in this module.. 
' Some functions do reference object classes residing in other classes

Imports System.Net

Module Network_Functions
    Private Net_Data As String
    Private In_data() As String
    Private Loop_1 As Integer
    Private Tmp_Int As Integer
    Private Tmp_Bool As Boolean

    Public Function GetLIPAdresses() As ArrayList
        Dim NetInterfaces() As NetworkInformation.NetworkInterface = NetworkInformation.NetworkInterface.GetAllNetworkInterfaces
        Dim IPList As New ArrayList
        Try
            For Each NetInterface As NetworkInformation.NetworkInterface In NetInterfaces
                Dim infosDns As NetworkInformation.UnicastIPAddressInformationCollection = NetInterface.GetIPProperties.UnicastAddresses
                For Each address As NetworkInformation.UnicastIPAddressInformation In infosDns
                    IPList.Add(address.Address.ToString)
                Next
            Next
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message)
        End Try
        Return IPList
    End Function

    Public Function Search_L_N() As Boolean
        Dim Dest_IP As New IPEndPoint(IPAddress.Parse("255.255.255.255"), L_Port)
        Net_Data = "LOGI:" & User(0).IP.ToString & ":" & User(0).Name & ":" & User(0).T_Colour.ToString & ":" & User(0).Hidden.ToString
        Main_F.UDPSock.Send(Net_Data, Dest_IP)
        Dest_IP = Nothing
    End Function

    Public Function New_User(ByVal D_IP As Net.IPAddress) As Boolean
        Dim Dest_IP As New IPEndPoint(D_IP, L_Port)
        Net_Data = "USER:" & User(0).IP.ToString & ":" & User(0).Name & ":" & User(0).T_Colour.ToString & ":" & User(0).Hidden.ToString
        Main_F.UDPSock.Send(Net_Data, Dest_IP)
        Dest_IP = Nothing
    End Function

    Public Function Log_out() As Boolean
        Dim Dest_IP As New IPEndPoint(IPAddress.Parse("255.255.255.255"), L_Port)
        Net_Data = "LOGO:" & User(0).IP.ToString & ":" & User(0).Name
        Main_F.UDPSock.Send(Net_Data, Dest_IP)
        Dest_IP = Nothing
    End Function

    Public Function Add_User(ByVal data As String) As Boolean
        In_data = Split(data, ":", 5, CompareMethod.Text)
        ReDim Preserve In_data(4)
        Add_User = True
        For Each Tmp_User As MainF.User_Type In User
            If Tmp_User.IP.ToString = In_data(1) Then
                Tmp_User.Name = In_data(2)
                Tmp_User.T_Colour = CInt(In_data(3))
                Tmp_User.Hidden = CBool(In_data(4))
                Add_User = False
                Update_Users(True)
            End If
        Next
        If Add_User Then
            Loop_1 = UBound(User) + 1
            ReDim Preserve User(Loop_1)
            User(Loop_1).IP = Net.IPAddress.Parse(In_data(1))
            User(Loop_1).Name = In_data(2)
            User(Loop_1).T_Colour = CInt(In_data(3))
            User(Loop_1).Ignore = False
            User(Loop_1).Hidden = CBool(In_data(4))
            Add_User = True
            Update_Users(True, Loop_1)
        End If
    End Function

    Public Function Del_User(ByVal data As String) As Boolean
        In_data = Split(data, ":", 3, CompareMethod.Text)
        ReDim Preserve In_data(2)
        Del_User = False
        Tmp_Bool = False
        Tmp_Int = UBound(User) - 1
        For Loop_1 = 1 To Tmp_Int
            If User(Loop_1).IP.ToString = In_data(1) Then
                Tmp_Bool = True
                Del_User = True
            End If
            If Tmp_Bool Then
                User(Loop_1) = User(Loop_1 + 1)
            End If
        Next
        ReDim Preserve User(Tmp_Int)
        Delete_Users(In_data(2))
    End Function

End Module
