' This is a Buffer class incorperating the UDP transport protocol from system.net
' Since i could not find a event that is raised when data arrives to a specified 
' port i used a timer to check the socket for available data.. This may change if
' i find beter methods. 

Imports System.Net
Imports System.Text

Public Class UDPSocket_Buffer
    Private UDP_Sock As Sockets.UdpClient
    Private WithEvents C_Timer As System.Windows.Forms.Timer
    Private WithEvents I_Timer As System.Windows.Forms.Timer
    ' Thanks to ChaosTheEternal From CodeGuru for sorting out the Timer Threading problem..
    'Private WithEvents t_Timer As Timers.Timer - In IDE Starts a new processor thread
    Private B_Data() As String
    Private B_Sender() As IPAddress
    Private RecievedBytes() As Byte
    Private RemoteIpEndPoint As New IPEndPoint(IPAddress.IPv6Any, 0)
    Private Tot_Array As Integer
    Private Tmp_loop_1 As Integer
    Public Event Data_Arrival(ByVal Data As String, ByVal Source As IPAddress)
    Public Event Socket_Error(ByVal Err As Exception)

    Public Sub New()
        C_Timer = New System.Windows.Forms.Timer
        I_Timer = New System.Windows.Forms.Timer
        C_Timer.Interval = 100
        I_Timer.Interval = 1000
        ReDim B_Data(0)
        ReDim B_Sender(0)
    End Sub

    Public Function Init(ByVal Port As Integer) As Boolean
        Try
            UDP_Sock = New Sockets.UdpClient(Port)
            UDP_Sock.EnableBroadcast = True
            C_Timer.Enabled = True
            Init = True
        Catch ex As Exception
            Init = False
            RaiseEvent Socket_Error(ex)
        End Try
    End Function
    Public Function Close() As Boolean
        Try
            UDP_Sock.Close()
            UDP_Sock = Nothing
            C_Timer.Enabled = False
            Close = True
        Catch ex As Exception
            Close = False
        End Try
    End Function

    Public Function Send(ByVal Data As String, ByVal Address As IPEndPoint) As Boolean
        Try
            UDP_Sock.Send(Encoding.ASCII.GetBytes(Data), Len(Data), Address)
            Send = True
        Catch ex As Exception
            Send = False
            RaiseEvent Socket_Error(ex)
        End Try
    End Function

    Private Sub C_Timer_Elapsed(ByVal sender As Object, ByVal e As System.EventArgs) Handles C_Timer.Tick
        If UDP_Sock.Available > 0 Then
            Try
                RecievedBytes = UDP_Sock.Receive(RemoteIpEndPoint)
                Tot_Array = UBound(B_Data) + 1
                ReDim B_Data(Tot_Array)
                ReDim B_Sender(Tot_Array)
                B_Data(Tot_Array) = Trim(Encoding.ASCII.GetString(RecievedBytes))
                B_Sender(Tot_Array) = RemoteIpEndPoint.Address
                I_Timer.Enabled = True
            Catch ex As Exception
                RaiseEvent Socket_Error(ex)
            End Try
        End If
    End Sub

    Private Sub I_Timer_Elapsed(ByVal sender As Object, ByVal e As System.EventArgs) Handles I_Timer.Tick
        Tot_Array = UBound(B_Data)
        If Tot_Array > 0 Then
            For Tmp_loop_1 = 0 To Tot_Array - 1
                B_Data(Tmp_loop_1) = B_Data(Tmp_loop_1 + 1)
                B_Sender(Tmp_loop_1) = B_Sender(Tmp_loop_1 + 1)
            Next
            ReDim Preserve B_Data(Tot_Array - 1)
            ReDim Preserve B_Sender(Tot_Array - 1)
            If B_Data(0) <> "" Then
                RaiseEvent Data_Arrival(B_Data(0), B_Sender(0))
            End If
        Else
            I_Timer.Enabled = False
        End If
    End Sub

    Protected Overrides Sub Finalize()
        Try
            UDP_Sock.Close()
            UDP_Sock = Nothing
        Catch ex As Exception
            ' Socket already closed or never initiated..
            ' since we closing we can ignore this error..
        End Try
        C_Timer = Nothing
        I_Timer = Nothing
        MyBase.Finalize()
    End Sub

End Class
